"use client";

// src/use-badge.ts
import { badge } from "@nextui-org/theme";
import { mapPropsVariants } from "@nextui-org/system";
import { useDOMRef } from "@nextui-org/react-utils";
import { clsx } from "@nextui-org/shared-utils";
import { useMemo } from "react";
function useBadge(originalProps) {
  const [props, variantProps] = mapPropsVariants(originalProps, badge.variantKeys);
  const { as, ref, children, className, content, classNames, ...otherProps } = props;
  const Component = as || "span";
  const domRef = useDOMRef(ref);
  const isOneChar = useMemo(
    () => {
      var _a;
      return ((_a = String(content)) == null ? void 0 : _a.length) === 1 || (originalProps == null ? void 0 : originalProps.isOneChar);
    },
    [content, originalProps == null ? void 0 : originalProps.isOneChar]
  );
  const isDot = useMemo(() => {
    var _a;
    return ((_a = String(content)) == null ? void 0 : _a.length) === 0;
  }, [content]);
  const baseStyles = clsx(classNames == null ? void 0 : classNames.badge, className);
  const slots = useMemo(
    () => badge({
      ...variantProps,
      isOneChar,
      isDot
    }),
    [...Object.values(variantProps), isOneChar, isDot]
  );
  const getBadgeProps = () => {
    return {
      ref: domRef,
      className: slots.badge({ class: baseStyles }),
      "data-invisible": originalProps.isInvisible,
      ...otherProps
    };
  };
  return {
    Component,
    children,
    content,
    slots,
    classNames,
    disableAnimation: originalProps == null ? void 0 : originalProps.disableAnimation,
    isInvisible: originalProps == null ? void 0 : originalProps.isInvisible,
    getBadgeProps
  };
}

export {
  useBadge
};
